library(growth)

feed <- cbind(c(rep(0,25),rep(1,27),rep(0,27)),
	c(rep(0,25),rep(0,27),rep(1,27)))

# right
milk <- read.table("milk2.dat")
milk2 <- data.matrix(data.frame(milk))
milk2[milk2 == 9.99] <- NA
br <- rep(0,79)
for(i in 1:79)for(j in 1:19)if(!is.na(milk2[i,j])){
	br[i] <- j-1
	break}
# cohorts
ttf <- cbind(br==1,br==3,br==4,br==5)
ttf2 <- br==0
ttf3 <- br==5

# eliminate start
milk4 <- milk2
for(i in 1:79)milk4[i,br[i]+1] <- NA

# eliminate after missing
milk4 <- milk2
milk4[,2:19][is.na(milk4[,1:18])] <- NA
for(i in 1:79)milk4[i,br[i]+1] <- milk2[i,br[i]+1]

# eliminate before missing
milk4 <- milk2
milk4[,1:18][is.na(milk4[,2:19])] <- NA

# eliminate missing and start
milk4 <- milk2
milk4[,2:19][is.na(milk4[,1:18])] <- NA
milk4[,1] <- NA
#milk2 <- milk4

#left
milk <- read.table("milk.dat")
milk <- data.matrix(data.frame(milk))
milk[milk == 9.99] <- NA

# eliminate start
milk3 <- milk[,-1]

# eliminate after missing
milk3 <- milk
milk3[,2:14][is.na(milk3[,1:13])] <- NA
for(i in 1:79)milk3[i,19-br[i]] <- milk[i,19-br[i]]

# eliminate before missing
milk3 <- milk
milk3[,1:13][is.na(milk3[,2:14])] <- NA

# eliminate missing and start
milk3 <- milk[,-1]
milk3[,2:13][is.na(milk3[,1:12])] <- NA
#milk <- milk3

print(z0 <- carma(milk2))
	# AIC 423.4117
print(z1 <- carma(milk2,torder=1))
	# AIC 419.1527
print(z1a <- carma(milk,torder=1))
	# AIC 418.412
print(z1b <- carma(milk2,torder=2))
	# AIC 420.0614
print(z1c <- carma(milk,torder=2))
	# AIC 385.4173
print(z1d <- carma(milk2,torder=3))
	# AIC 377.9698
print(z1e <- carma(milk,torder=3))
	# AIC 363.5692
print(z2 <- carma(milk2,pre=0.7,pos=c(1,1)))
	# AIC 259.5681
print(z3 <- carma(milk2,ccov=feed))
	# AIC 375.365
print(z3a <- carma(milk,ccov=feed))
	# AIC 375.365
print(z3b <- carma(milk2,torder=3,ccov=feed))
	# AIC 326.0327
print(z3c <- carma(milk,torder=3,ccov=feed))
	# AIC 310.1424
rm(z0,z1,z1a,z1b,z1c,z1d,z1e,z2,z3,z3a,z3b,z3c)
print(z4 <- carma(milk2,arma=c(1,0,0),parma=1))
	# AIC 87.34135
print(z4a <- carma(milk,arma=c(1,0,0),parma=1))
	# AIC 
print(z5 <- carma(milk2,ccov=feed,arma=c(1,0,0),parma=-0.9))
	# AIC 79.43421
print(z5a <- carma(milk,ccov=feed,arma=c(1,0,0),parma=-0.9))
	# AIC 
print(z6 <- carma(milk2,ccov=feed,torder=1,arma=c(1,0,0),parma=-1))
	# AIC 59.85526
print(z6a <- carma(milk,ccov=feed,torder=1,arma=c(1,0,0),parma=-1))
	# AIC 60.15245
print(z6b <- carma(milk2,torder=1,arma=c(1,0,0),parma=-1))
	# AIC 67.56086
print(z6c <- carma(milk,torder=1,arma=c(1,0,0),parma=-1))
	# AIC 68.26672
print(z7 <- carma(milk2,ccov=feed,torder=2,arma=c(1,0,0),parma=-1))
	# AIC 59.32432
print(z7a <- carma(milk,ccov=feed,torder=2,arma=c(1,0,0),parma=-0.5))
	# AIC 38.99111
print(z7b <- carma(milk2,torder=2,arma=c(1,0,0),parma=-1))
	# AIC 66.8437
print(z7c <- carma(milk,torder=2,arma=c(1,0,0),parma=-1))
	# AIC 48.38106
rm(z4,z4a,z5,z5a,z6,z6a,z6b,z6c,z7,z7a,z7b,z7c)
print(z8 <- carma(milk2,ccov=feed,torder=3,arma=c(1,0,0),parma=-1))
	# AIC 
	# full: 23.60006 
	# remove start: -74.04521 + 79 = 4.95479
	# remove after missing: 26.84068 + 10 = 36.84068
	# remove before missing: 16.83323 + 10 = 26.83323
	# neither start nor missing: -70.32632 + 89 = 18.67368
print(z8a <- carma(milk,ccov=feed,torder=3,arma=c(1,0,0),parma=-1))
	# AIC 
	# full: 12.68743
	# remove start: -55.299 + 79 = 23.701
	# remove after missing: 15.46900 + 10 = 25.46900
	# remove before missing: 3.350733 + 10 = 13.350733
	# neither start nor missing: -51.98784 + 89 = 37.01216
if(interactive()){
par(mfrow=c(2,2))
plot.profile(z8,1:19,c(0,0),ylim=c(0,5),plotse=F)
points(z8$time[rep(1:length(z8$nobs),z8$nobs)<=25],z8$y[rep(1:length(z8$nobs),z8$nobs)<=25],pch=0)
plot.profile(z8,1:19,c(1,0),ylim=c(0,4),lty=2,add=T,plotse=F)
plot.profile(z8,1:19,c(0,1),ylim=c(0,4),lty=4,add=T,plotse=F)
par(mfrow=c(1,1))
plot.residuals(z8)
plot.residuals(z8,recursive=F)
plot.residuals(z8,ccov=1)
plot.residuals(z8,ccov=1,recursive=F)
}

print(z8b <- carma(milk2,torder=3,arma=c(1,0,0),parma=-1))
	# AIC 32.17658
print(z8c <- carma(milk,torder=3,arma=c(1,0,0),parma=-1))
	# AIC 22.64922
print(z8d <- carma(milk2,ccov=cbind(feed,ttf),torder=3,arma=c(1,0,0),parma=-1))
	# 23.45843
print(z8e <- carma(milk,ccov=cbind(feed,ttf),torder=3,arma=c(1,0,0),parma=-1))
	# 13.30378
print(z8f <- carma(milk2,ccov=cbind(feed,ttf3),torder=3,arma=c(1,0,0),parma=-1))
	# 20.74067
print(z8g <- carma(milk,ccov=cbind(feed,ttf3),torder=3,arma=c(1,0,0),parma=-1))
	# 13.40782
rm(z8,z8a,z8b,z8c,z8d,z8e,z8f,z8g)
print(z9 <- carma(milk2,ccov=feed,torder=3,interact=c(3,3),
	arma=c(1,0,0),parma=-1))
	# AIC 28.24486

if(interactive()){
plot.profile(z9,1:19,c(0,0),ylim=c(0,4))
plot.profile(z9,1:19,c(1,0),ylim=c(0,4),lty=2,add=T)
plot.profile(z9,1:19,c(0,1),ylim=c(0,4),lty=4,add=T)
print(z10 <- carma(milk2,ccov=feed,torder=3,interact=c(2,2),
	arma=c(1,0,0),parma=-1))
	# AIC 27.24523
plot.profile(z10,1:19,c(0,0),ylim=c(0,4))
plot.profile(z10,1:19,c(1,0),ylim=c(0,4),lty=2,add=T)
plot.profile(z10,1:19,c(0,1),ylim=c(0,4),lty=4,add=T)
}

print(z11 <- carma(milk2,ccov=feed,torder=3,interact=c(1,1),
	arma=c(1,0,0),parma=-1))
	# AIC 25.39523

if(interactive()){
plot.profile(z11,1:19,c(0,0),ylim=c(0,4))
plot.profile(z11,1:19,c(1,0),ylim=c(0,4),lty=2,add=T)
plot.profile(z11,1:19,c(0,1),ylim=c(0,4),lty=4,add=T)
}

#print(z12 <- carma(milk2,ccov=feed,torder=3,arma=c(2,0,0),parma=c(-1,-0.3),print.level=2))
print(z13 <- carma(milk2,ccov=feed,torder=3,arma=c(1,0,1),parma=c(-1,0.3)))
	# AIC -11.58307

if(interactive()){
plot.profile(z13,1:19,c(0,0),ylim=c(0,4))
plot.profile(z13,1:19,c(1,0),ylim=c(0,4),lty=2,add=T)
plot.profile(z13,1:19,c(0,1),ylim=c(0,4),lty=4,add=T)
par(mfrow=c(3,3))
for(i in 1:9)plot.iprofile(z13,i,ylim=c(0,5),xlim=c(1,19),main="Cow")
par(mfrow=c(1,1))
}

print(z13a <- carma(milk,ccov=feed,torder=3,arma=c(1,0,1),
	parma=c(-1.734,0.535)))
	# AIC -15.00594

if(interactive()){
#postscript("profile.eps",landscape=F,height=5)
plot.profile(z13a,1:19,c(0,1),ylim=c(0,4),plotse=F,xlab="Week",lty=3,
	ylab="Protein level")
plot.profile(z13a,1:19,c(1,0),ylim=c(0,4),plotse=F,lty=2,add=T)
plot.profile(z13a,1:19,c(0,0),ylim=c(0,4),plotse=F,lty=1,add=T)
legend(1,2.5,legend=c("Barley","Mixed","Lupins"),lty=c(1,2,3))
#postscript("iprofile.eps",landscape=F)
par(mfrow=c(3,3))
for(i in 10:12)plot.iprofile(z13a,i,ylim=c(0,5),xlim=c(1,19),main="Cow")
for(i in 44:46)plot.iprofile(z13a,i,ylim=c(0,5),xlim=c(1,19),main="Cow")
for(i in 73:75)plot.iprofile(z13a,i,ylim=c(0,5),xlim=c(1,19),main="Cow")
#postscript("residual.eps",landscape=F)
par(mfrow=c(3,3))
plot.residuals(z13a,ylim=c(-4,4),xlim=c(1,19),nobs=10,main="Cow 10")
plot.residuals(z13a,ylim=c(-4,4),xlim=c(1,19),nobs=11,main="Cow 11")
plot.residuals(z13a,ylim=c(-4,4),xlim=c(1,19),nobs=12,main="Cow 12")
plot.residuals(z13a,ylim=c(-4,4),xlim=c(1,19),nobs=44,main="Cow 44")
plot.residuals(z13a,ylim=c(-4,4),xlim=c(1,19),nobs=45,main="Cow 45")
plot.residuals(z13a,ylim=c(-4,4),xlim=c(1,19),nobs=46,main="Cow 46")
plot.residuals(z13a,ylim=c(-4,4),xlim=c(1,19),nobs=73,main="Cow 73")
plot.residuals(z13a,ylim=c(-4,4),xlim=c(1,19),nobs=74,main="Cow 74")
plot.residuals(z13a,ylim=c(-4,4),xlim=c(1,19),nobs=75,main="Cow 75")
par(mfrow=c(1,1))
}

print(z13b <- carma(milk2,torder=3,arma=c(1,0,1),parma=c(-2.15,0.519)))
	# AIC -7.55011
print(z13c <- carma(milk,torder=3,arma=c(1,0,1),parma=c(-1.734,0.535)))
	# AIC -9.181943
print(z13d <- carma(milk2,ccov=cbind(feed,ttf),torder=3,arma=c(1,0,1),
	parma=c(-1,0.3)))
	# AIC -10.63496
print(z13e <- carma(milk,ccov=cbind(feed,ttf),torder=3,arma=c(1,0,1),
	parma=c(-1.734,0.535)))
	# AIC -14.41082
print(z13f <- carma(milk2,ccov=cbind(feed,ttf3),torder=3,arma=c(1,0,1),
	parma=c(-1,0.3)))
	# AIC -13.48102
print(z13g <- carma(milk,ccov=cbind(feed,ttf2),torder=3,arma=c(1,0,1),
	parma=c(-1.721,0.535)))
	# AIC -15.78594
print(z13h <- carma(milk,ccov=cbind(feed,ttf3),torder=3,arma=c(1,0,1),
	parma=c(-1.734,0.535)))
	# AIC -14.03598
rm(z9,z10,z11,z13,z13a,z13b,z13c,z13d,z13e,z13f,z13g,z13h)
print(z14 <- carma(milk2,ccov=feed,torder=1,arma=c(1,0,1),parma=c(-1,0.3)))
	# AIC 41.23428
print(z15 <- carma(milk2,ccov=feed,torder=3,pre=1,pos=c(1,1)))
	# AIC 184.1976
print(z16 <- carma(milk2,ccov=feed,torder=3,arma=c(1,0,1),parma=c(-2,0.54),
	pre=1,pos=c(1,1)))
	# AIC -10.58389
print(z16a <- carma(milk,ccov=feed,torder=3,arma=c(1,0,1),parma=c(-1.719,0.534),
	pre=0.08,pos=c(1,1)))
	# AIC -14.00647
#print(z17 <- carma(milk2,ccov=feed,torder=3,arma=c(1,0,1),parma=c(-1,0.3),
#	pre=1,pos=c(2,2)))
print(z18 <- carma(milk2,ccov=feed,torder=3,arma=c(1,0,1),parma=c(-2,0.54),
	pre=c(1,1),pos=rbind(c(1,1),c(2,2))))
	# AIC -9.599395
rm(z14,z15,z16,z16a,z17,z18)
print(z19 <- carma(milk2,ccov=feed,torder=3,arma=c(1,0,0),
	parma=-0.647,pre=-0.433,pos=c(1,1),ndigit=16,
	gradtol=0.000000001,steptol=0.000000001))
	# AIC 20.12175
print(z19a <- carma(milk,ccov=feed,torder=3,arma=c(1,0,0),
	parma=-0.647,pre=-0.433,pos=c(1,1),ndigit=16,
	gradtol=0.000000001,steptol=0.000000001))
	# AIC  7.161423
print(z19b <- carma(milk2,ccov=feed,torder=3,arma=c(1,0,0),
	parma=-0.488,pre=c(-0.5,-0.05),pos=rbind(c(1,1),c(2,2))))
	# AIC 18.90261
print(z19c <- carma(milk,ccov=feed,torder=3,arma=c(1,0,0),
	parma=-0.495,pre=c(-0.44,-0.035),pos=rbind(c(1,1),c(2,2))))
	# AIC 6.069575
print(z19d <- carma(milk2,ccov=feed,torder=3,arma=c(1,0,0),
	parma=-0.326,pre=c(-0.625,-0.052,-0.004),
	pos=rbind(c(1,1),c(2,2),c(3,3))))
	# AIC 17.59106
print(z19e <- carma(milk,ccov=feed,torder=3,arma=c(1,0,0),
	parma=-0.338,pre=c(-0.51,-0.013,-0.003),
	pos=rbind(c(1,1),c(2,2),c(3,3))))
	# AIC 4.642704
rm(z19,z19a,z19b,z19c,z19d,z19e)
print(z20 <- carma(milk2,ccov=feed,torder=3,arma=c(2,0,1),parma=c(-2,0,0.54)))
	# AIC -10.80684
print(z20a <- carma(milk,ccov=feed,torder=3,arma=c(2,0,1),
	parma=c(-2.06,-0.57,0.684),steptol=0.00000001))
	# AIC -17.51768
print(z20b <- carma(milk2,ccov=feed,torder=3,arma=c(3,0,1),
	parma=c(0.3,2.3,1.9,0.57)))
	# AIC -9.583397
print(z20c <- carma(milk,ccov=feed,torder=3,arma=c(3,0,1),
	parma=c(-1.58,-1.86,-2.41,0.719),steptol=0.00000001))
	# AIC -20.81091
print(z20d <- carma(milk2,ccov=feed,torder=3,arma=c(4,0,1),
	parma=c(0.3,2.3,1.9,1,0.57)))
	# AIC 
print(z20e <- carma(milk,ccov=feed,torder=3,arma=c(4,0,1),
	parma=c(-1.58,-1.86,-2.41,1,0.719),steptol=0.00000001))
	# AIC -19.79019
print(z21 <- carma(milk2,ccov=cbind(feed,ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	torder=3,arma=c(1,0,1),parma=c(-1,0.3)))
	# AIC -13.40552
print(z21a <- carma(milk,ccov=cbind(feed,ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	torder=3,arma=c(1,0,1),parma=c(-1.734,0.535)))
	# AIC -18.54658
print(z21b <- carma(milk2,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	torder=3,arma=c(1,0,1),parma=c(-1,0.3)))
	# AIC -15.33689
print(z21c <- carma(milk,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	torder=3,arma=c(1,0,1),parma=c(-1.734,0.535)))
	# AIC -20.39491
print(z21d <- carma(milk2,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,0,0),torder=3,arma=c(1,0,1),parma=c(-1,0.3)))
	# AIC -58.95052
print(z21da <- carma(milk2,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(1,0,0),torder=3,arma=c(1,0,1),parma=c(-1,0.3)))
	# AIC -59.87793

if(interactive()){
#postscript("profile2.eps",landscape=F)
par(mfrow=c(1,1))
plot.profile(z21da,1:19,c(0,0,0),ylim=c(0,5),plotse=F,xlab="Week",
	ylab="Protein level")
plot.profile(z21da,1:19,c(1,0,0),lty=2,add=T,plotse=F)
plot.profile(z21da,1:19,c(1,1,0),lty=3,add=T,plotse=F)
plot.profile(z21da,1:19,c(1,0,1),lty=4,add=T,plotse=F)
#postscript("iprofil2.eps",landscape=F)
par(mfrow=c(3,3))
for(i in 10:12)plot.iprofile(z21da,i,ylim=c(0,5),xlim=c(1,19),main="Cow")
for(i in 44:46)plot.iprofile(z21da,i,ylim=c(0,5),xlim=c(1,19),main="Cow")
for(i in 73:75)plot.iprofile(z21da,i,ylim=c(0,5),xlim=c(1,19),main="Cow")
}

print(z21db <- carma(milk2,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	torder=3,arma=c(1,0,1),parma=c(-1,0.3)))
	# AIC -15.33689
print(z21e <- carma(milk,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,0,0),torder=3,arma=c(1,0,1),parma=c(-1,0.3)))
	# AIC -57.6549
print(z21f <- carma(milk2,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,2,2),torder=3,arma=c(1,0,1),parma=c(-1,0.3)))
	# AIC -55.69656
print(z21g <- carma(milk,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,2,2),torder=3,arma=c(1,0,1),parma=c(-1,0.3)))
	# AIC -54.39423
print(z21h <- carma(milk2,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,0,0),torder=3,arma=c(2,0,1),parma=c(0.3,2,0.7)))
	# AIC -57.9547
print(z21i <- carma(milk,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,0,0),torder=3,arma=c(2,0,1),parma=c(0.3,2,0.7)))
	# AIC -56.65473
print(z21j <- carma(milk2,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,0,0),torder=3,arma=c(3,0,1),parma=c(-0.1,1.8,2,0.7)))
	# AIC -56.95
print(z21k <- carma(milk,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,0,0),torder=3,arma=c(3,0,1),parma=c(-0.1,1.8,2,0.7)))
	# AIC -55.65067
print(z22 <- carma(milk2,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,0,0),torder=3,arma=c(1,0,1),parma=c(-1,0.3),
	pre=-0.4,pos=c(1,1)))
	# AIC -58.38299
print(z22a <- carma(milk,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,0,0),torder=3,arma=c(1,0,1),parma=c(-1,0.3),
	pre=-0.4,pos=c(1,1)))
	# AIC -57.00645
print(z22b <- carma(milk2,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,0,0),torder=3,arma=c(1,0,1),parma=c(-1.6,0.7),
	pre=c(-0.4,0.1),pos=rbind(c(1,1),c(2,2))))
	# AIC -57.38299
print(z22c <- carma(milk,ccov=cbind(ttf2,feed[,1]*ttf2,feed[,2]*ttf2),
	interact=c(2,0,0),torder=3,arma=c(1,0,1),parma=c(-1,0.3),
	pre=c(-0.4,0.1),pos=rbind(c(1,1),c(2,2))))
	# AIC -56.20654
